=== debian/changelog ===
libvcflib (1.0.3+dfsg-2) unstable; urgency=medium

  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 07 Oct 2022 16:26:06 +0200

libvcflib (1.0.3+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version

  [ Sascha Steinbiss ]
  * Team upload.
  * Fix manpage paths.

 -- Sascha Steinbiss <satta@debian.org>  Sun, 20 Feb 2022 19:24:58 +0100

libvcflib (1.0.2+dfsg-5) unstable; urgency=medium

  [ Vagrant Cascadian ]
  * Enable reproducible by avoid to embed the full path in RPATH
    Closes: #1003808

  [ Andreas Tille ]
  * Add missing build dependency on dh addon.

 -- Andreas Tille <tille@debian.org>  Mon, 17 Jan 2022 20:53:03 +0100

libvcflib (1.0.2+dfsg-4) unstable; urgency=medium

  * Install scripts
    Closes: #989014

 -- Andreas Tille <tille@debian.org>  Fri, 24 Dec 2021 10:51:57 +0100

libvcflib (1.0.2+dfsg-3) unstable; urgency=medium

  * Fix build with gcc-11
    Closes: #984139
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 20 Oct 2021 18:33:54 +0200
