=== debian/control ===
Source: libvcflib
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               markdown <!nodoc>,
               libtabixpp-dev,
               libbz2-dev,
               libdisorder-dev,
               libsmithwaterman-dev,
               libssw-dev,
               libfastahack-dev,
               pkg-config,
               libgtest-dev <!nocheck>,
               debhelper
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/libvcflib
Vcs-Git: https://salsa.debian.org/med-team/libvcflib.git
Homepage: https://github.com/vcflib/vcflib
Rules-Requires-Root: no

Package: libvcflib1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C++ library for parsing and manipulating VCF files
 The Variant Call Format (VCF) is a flat-file, tab-delimited textual format
 intended to concisely describe reference-indexed variations between
 individuals. VCF provides a common interchange format for the description of
 variation in individuals and populations of samples, and has become the defacto
 standard reporting format for a wide array of genomic variant detectors.
 .
 vcflib provides methods to manipulate and interpret sequence variation as it
 can be described by VCF. It is both:
 .
  * an API for parsing and operating on records of genomic variation as it can
    be described by the VCF format,
  * and a collection of command-line utilities for executing complex
    manipulations on VCF files.

Package: libvcflib-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libvcflib1 (= ${binary:Version}),
         libdisorder-dev,
         libfastahack-dev,
         libtabixpp-dev,
         libsmithwaterman-dev,
         libssw-dev
Description: C++ library for parsing and manipulating VCF files (development)
 The Variant Call Format (VCF) is a flat-file, tab-delimited textual format
 intended to concisely describe reference-indexed variations between
 individuals. VCF provides a common interchange format for the description of
 variation in individuals and populations of samples, and has become the defacto
 standard reporting format for a wide array of genomic variant detectors.
 .
 vcflib provides methods to manipulate and interpret sequence variation as it
 can be described by VCF. It is both:
 .
  * an API for parsing and operating on records of genomic variation as it can
    be described by the VCF format,
  * and a collection of command-line utilities for executing complex
    manipulations on VCF files.
 .
 This package contains the static library and the header files.

Package: libvcflib-tools
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python3:any,
         r-base-core,
         r-cran-plyr,
         r-cran-ggplot2,
         r-cran-gridbase
Suggests: r-cran-pracma
Breaks: libvcflib1 (<= 1.0.0~rc2+dfsg-3)
Replaces: libvcflib1 (<= 1.0.0~rc2+dfsg-3)
Description: C++ library for parsing and manipulating VCF files (tools)
 The Variant Call Format (VCF) is a flat-file, tab-delimited textual format
 intended to concisely describe reference-indexed variations between
 individuals. VCF provides a common interchange format for the description of
 variation in individuals and populations of samples, and has become the defacto
 standard reporting format for a wide array of genomic variant detectors.
 .
 vcflib provides methods to manipulate and interpret sequence variation as it
 can be described by VCF. It is both:
 .
  * an API for parsing and operating on records of genomic variation as it can
    be described by the VCF format,
  * and a collection of command-line utilities for executing complex
    manipulations on VCF files.
 .
 This package contains several tools using the library.
