=== debian/changelog ===
libvcflib (1.0.9+dfsg1-3build1) noble; urgency=medium

  * No-change rebuild against libtabixpp0t64.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 14 Apr 2024 19:01:17 +0100

libvcflib (1.0.9+dfsg1-3) unstable; urgency=medium

  * add support for loong64 arch
    Closes: #1057253

 -- Andreas Tille <tille@debian.org>  Sun, 03 Dec 2023 13:29:41 +0100

libvcflib (1.0.9+dfsg1-2) unstable; urgency=medium

  * Source-only upload.

 -- Andreas Tille <tille@debian.org>  Sun, 06 Aug 2023 23:01:54 +0200

libvcflib (1.0.9+dfsg1-1) unstable; urgency=medium

  * Bump SOVERSION due to ABI change
    Closes: #1032557
  * Attempt to use d-shlibs delayed for later once shared and static lib
    are created both
  * Drop unneeded header files with questionable licenses

 -- Andreas Tille <tille@debian.org>  Sun, 23 Jul 2023 10:42:25 +0200

libvcflib (1.0.9+dfsg-1) unstable; urgency=medium

  [ Étienne Mollier ]
  * New upstream version 1.0.9+dfsg
  * d/patches: refresh everything.
  * wfa2_linking: add patch; fix linker errors.

  [ Andreas Tille ]
  * libvcflib-dev: Depends: libwfa2-dev
    Closes: #1031473

 -- Andreas Tille <tille@debian.org>  Sun, 19 Feb 2023 13:54:18 +0100

libvcflib (1.0.7+dfsg-2) unstable; urgency=medium

  * Restrict architectures to 64bit only

 -- Andreas Tille <tille@debian.org>  Tue, 07 Feb 2023 21:10:50 +0100

libvcflib (1.0.7+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Do not support ZIG compiler which is not packaged yet
  * Build-Depends: python3-pybind11, libtabixpp-dev
  * Fix name of upstream download tarball in watch file
  * Versioned Build-Depends: libwfa2-dev (>= 2.3.2)
  * Do not exclude Files that are not in upstream tarball any more
  * New upstream version 1.0.6+dfsg

  [ Nilesh Patra ]
  * d/rules: Set WFA_GITMODULE to OFF
  * Refresh/update patches
  * Add some ext modules that are missed out in the tarball
  * Add rules for getting ext libs to contrib and adding clean rules for
    pruning them off for consecutive clean builds
  * Add build depends on libhts-dev and python3-dev
  * Pass more flags to get past the configure step
  * d/rules: Get tests running, do not install py shared object lib

 -- Andreas Tille <tille@debian.org>  Tue, 07 Feb 2023 18:37:40 +0100
