=== debian/control ===
--- 
+++ 
@@ -4,25 +4,29 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+#               d-shlibs, # Switch to d-shlibs once shared and static lib are built
                cmake,
                markdown <!nodoc>,
                libtabixpp-dev,
                libbz2-dev,
                libdisorder-dev,
+               libhts-dev,
                libsmithwaterman-dev,
                libssw-dev,
                libfastahack-dev,
+               libwfa2-dev,
                pkg-config,
                libgtest-dev <!nocheck>,
-               debhelper
-Standards-Version: 4.6.1
+               python3-dev,
+               python3-pybind11
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/libvcflib
 Vcs-Git: https://salsa.debian.org/med-team/libvcflib.git
 Homepage: https://github.com/vcflib/vcflib
 Rules-Requires-Root: no
 
-Package: libvcflib1
-Architecture: any
+Package: libvcflib2
+Architecture: any-amd64 arm64 loong64 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 alpha
 Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends},
@@ -43,16 +47,17 @@
     manipulations on VCF files.
 
 Package: libvcflib-dev
-Architecture: any
+Architecture: any-amd64 arm64 loong64 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 alpha
 Multi-Arch: same
 Section: libdevel
 Depends: ${misc:Depends},
-         libvcflib1 (= ${binary:Version}),
+         libvcflib2 (= ${binary:Version}),
          libdisorder-dev,
          libfastahack-dev,
          libtabixpp-dev,
          libsmithwaterman-dev,
-         libssw-dev
+         libssw-dev,
+         libwfa2-dev
 Description: C++ library for parsing and manipulating VCF files (development)
  The Variant Call Format (VCF) is a flat-file, tab-delimited textual format
  intended to concisely describe reference-indexed variations between
@@ -71,7 +76,7 @@
  This package contains the static library and the header files.
 
 Package: libvcflib-tools
-Architecture: any
+Architecture: any-amd64 arm64 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 alpha
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          python3:any,
@@ -80,8 +85,6 @@
          r-cran-ggplot2,
          r-cran-gridbase
 Suggests: r-cran-pracma
-Breaks: libvcflib1 (<= 1.0.0~rc2+dfsg-3)
-Replaces: libvcflib1 (<= 1.0.0~rc2+dfsg-3)
 Description: C++ library for parsing and manipulating VCF files (tools)
  The Variant Call Format (VCF) is a flat-file, tab-delimited textual format
  intended to concisely describe reference-indexed variations between
