=== debian/watch ===
version=4

opts="uversionmangle=s/-rc/~rc/,repacksuffix=+dfsg,dversionmangle=auto,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/vcflib/vcflib/tags .*/v(\d[-\d.rc]+)\.tar\.gz
