## libvcflib 1.0.12+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,10 @@
 # For Debian currently with
 #
 #   cd build
-#   cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo -DZIG=OFF -DWFA_GITMODULE=OFF ..
-#   make
-#   make test
-#   make install
+#   cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo -DZIG=OFF ..
+#   cmake --build .
+#   ctest .
+#   cmake --install .
 #
 cmake_minimum_required(VERSION 3.16)
 project(vcflib)
@@ -38,8 +38,7 @@
 option(GPROF "Enable gprof profiling" OFF)
 option(ASAN "Use address sanitiser" OFF)
 option(ZIG "Set to OFF to disable the zig code" ON)
-option(WFA_GITMODULE "Force local git submodule for WFA2LIB" ON) # disable in distros, you may need to add path to WFA_INCLUDE_DIRS
-
+option(WFA_GITMODULE "Force local git submodule for WFA2LIB" OFF) # disabled by default now
 include(CheckIPOSupported) # adds lto
 check_ipo_supported(RESULT ipo_supported OUTPUT output)
 
@@ -76,14 +75,14 @@
 endif()
 
 if ((${CMAKE_BUILD_TYPE} MATCHES Release) OR (${CMAKE_BUILD_TYPE} MATCHES RelWithDebInfo))
-  set (CMAKE_C_FLAGS "${OpenMP_C_FLAGS} ${EXTRA_FLAGS}")
-  set (CMAKE_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${EXTRA_FLAGS}")
+  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_FLAGS}")
+  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_FLAGS}")
 endif ()
 
 if (${CMAKE_BUILD_TYPE} MATCHES "Debug")
   set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_FLAGS}")
   set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_FLAGS}")
-  add_definitions(-Wfatal-errors)
+  add_definitions(-Wfatal-errors) # stop after first error
 endif ()
 
 if (ASAN)
@@ -112,16 +111,26 @@
 include_directories(contrib/fastahack)
 include_directories(contrib/intervaltree)
 include_directories(contrib/smithwaterman)
-include_directories(contrib/multichoose)
+# include_directories(contrib/multichoose) merged with vcflib
 include_directories(contrib/filevercmp)
 include_directories(contrib/c-progress-bar)
 
-if(NOT HTSLIB_FOUND)
+if(HTSLIB_FOUND)
+  list(JOIN HTSLIB_CFLAGS " " HTSLIB_CFLAGS_STRING)
+  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${HTSLIB_CFLAGS_STRING}")
+  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${HTSLIB_CFLAGS_STRING}")
+else(HTSLIB_FOUND)
+  message(STATUS "Using included htslib")
   set(HTSLIB_LOCAL contrib/tabixpp/htslib)
-  set(TABIX_FOUND OFF) # also build tabixpp if htslib is missing
-endif()
-
-if (NOT TABIX_FOUND)
+  set(TABIXPP_FOUND OFF) # also build tabixpp if htslib is missing
+endif()
+
+if(TABIXPP_FOUND)
+  list(JOIN TABIXPP_CFLAGS " " TABIXPP_CFLAGS_STRING)
+  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${TABIXPP_CFLAGS_STRING}")
+  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${TABIXPP_CFLAGS_STRING}")
+else(TABIXPP_FOUND)
+  message(STATUS "Using included tabixpp")
   set(TABIXPP_LOCAL contrib/tabixpp)
   include_directories(contrib/tabixpp)
   set(tabixpp_SOURCE
@@ -135,24 +144,28 @@
 
 file(GLOB INCLUDES
   src/*.h*
-  contrib/multichoose/*.h*
+  # contrib/multichoose/*.h*
   contrib/intervaltree/*.h*
   contrib/smithwaterman/*.h*
   contrib/fastahack/*.h*
   contrib/filevercmp/*.h*
   )
 
+set(vcfwfa_SOURCE
+    src/legacy.cpp # introduces a WFA dependency
+    src/vcf-wfa.cpp
+)
+
 set(vcflib_SOURCE
+    ${vcfwfa_SOURCE}
     src/vcf-c-api.cpp
-    src/legacy.cpp
-    src/vcf-wfa.cpp
     src/Variant.cpp
+    src/canonicalize.cpp
     src/rnglib.cpp
     src/var.cpp
     src/pdflib.cpp
     src/cdflib.cpp
     src/split.cpp
-    src/legacy.cpp
     src/rkmh.cpp
     src/murmur3.cpp
     src/LeftAlign.cpp
@@ -217,16 +230,11 @@
     vcfsamplediff
     vcfremoveaberrantgenotypes
     vcfrandom
-    vcfparsealts
-    vcfstats
     vcfflatten
     vcfprimers
     vcfnumalt
-    vcfcleancomplex
     vcfintersect
     vcfannotate
-    vcfallelicprimitives
-    vcfwave
     vcfoverlay
     vcfaddinfo
     vcfkeepinfo
@@ -238,7 +246,6 @@
     vcfrandomsample
     vcfentropy
     vcfglxgt
-    vcfroc
     vcfcheck
     vcfstreamsort
     vcfuniq
@@ -264,6 +271,16 @@
     vcfinfosummarize
     vcfcreatemulti
 )
+
+
+set(WFBINS # Introduce wavefront dependency
+    vcfallelicprimitives
+    vcfcleancomplex
+    vcfparsealts
+    vcfroc
+    vcfstats
+    vcfwave
+  )
 
 set(SCRIPTS
     bed2region
@@ -359,16 +376,19 @@
 endif(HTSLIB_LOCAL)
 
 if(WFA_GITMODULE)
+  message(STATUS "Using included libwfa")
   set(WFA_INCLUDE_DIRS ${WFA_LOCAL})
-  add_subdirectory(${WFA_LOCAL} EXCLUDE_FROM_ALL)
+  add_subdirectory(${WFA_LOCAL})
   set(WFALIB wfa2) # pick up the wfa2 lib target from the included CMakeLists.txt
 else(WFA_GITMODULE)
+  include_directories($ENV{CMAKE_PREFIX_PATH}/include/wfa2lib)
   set(WFA_INCLUDE_DIRS ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}/wfa2lib)
-  find_library(WFALIB wfa2 wfa) # distro search for shared lib
-  if(NOT WFALIB)
-    message(STATUS "ERROR: Can not find libfwa! Make sure it is installed or use the git submodule instead")
-  endif()
+  find_library(WFALIB wfa2 wfa REQUIRED) # distro search for shared lib
 endif(WFA_GITMODULE)
+
+# if(NOT WFALIB)
+#   message(STATUS "ERROR: Can not find wfa2lib! Make sure it is installed or use the git submodule instead")
+# endif()
 
 include_directories(${WFA_INCLUDE_DIRS})
 MESSAGE(STATUS "WFA using include ${WFA_INCLUDE_DIRS}")
@@ -439,23 +459,6 @@
     add_dependencies(${BIN} vcflib)
     target_link_libraries(${BIN} PUBLIC ${vcflib_LIBS} vcflib)
   endforeach(BIN ${BINS})
-  # These binaries include WFALIB
-  target_link_libraries(vcfallelicprimitives PUBLIC ${WFALIB})
-  target_link_libraries(vcfcleancomplex PUBLIC ${WFALIB})
-  target_link_libraries(vcfparsealts PUBLIC ${WFALIB})
-  target_link_libraries(vcfroc PUBLIC ${WFALIB})
-  target_link_libraries(vcfstats PUBLIC ${WFALIB})
-  target_link_libraries(vcfwave PUBLIC ${WFALIB})
-  install(TARGETS ${BINS} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
-
-  # ---- Copy scripts
-  foreach(SCRIPT ${SCRIPTS})
-    install(PROGRAMS ./scripts/${SCRIPT} DESTINATION ${CMAKE_INSTALL_BINDIR} RENAME ${SCRIPT})
-  endforeach(SCRIPT ${SCRIPTS})
-
-endif()
-
-# ---- Python bindings - mostly for testing at this stage
-pybind11_add_module(pyvcflib "${CMAKE_SOURCE_DIR}/src/pythonffi.cpp")
-add_dependencies(pyvcflib ${vcflib_DEPS})
-target_link_libraries(pyvcflib PUBLIC vcflib ${vcflib_LIBS} ${WFALIB})
+  foreach(WFBIN ${WFBINS})
+    add_executable(${WFBIN} src/${WFBIN}.cpp ${vcfwfa_SOURCE})
+    add_dependencies(${WFBIN} vcflib)
