=== debian/changelog ===
libvcflib (1.0.12+dfsg-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * d/control: formally mark this package as 64-bit little-endian only.
    Closes: #1074044

  [ Étienne Mollier ]
  * d/watch: fix capture of pre-releases.
    Somehow, the scraping of Github tags page tended to meddle with the
    version capture, so this change introduces a switch to git mode, in
    addition to modifications to version mangling.
  * no_fsom patch: unfuzz.
  * shared_lib.patch: unfuzz.
  * tabix_linking.patch: unfuzz.
  * use_debian_packaged_fastahack.patch: refresh.
  * use_debian_packaged_libssw.patch: refresh.
  * use_debian_packaged_smithwaterman.patch: unfuzz.
  * wfa2_linking: unfuzz.
  * cmakelists-fixups.patch: new: fix a couple of configure issues.
  * d/libvcflib-tools.install: remove now missing vcfallelicprimitives.
  * d/libvcflib-dev.install: adjust to new target directory.

  [ Charles Plessy ]
  * Build-depend on discount instead of markdown
    Closes: #1073098

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)
  * Replace transitional package pkg-config by pkgconf in Build-Depends
    (routine-update)

 -- Andreas Tille <tille@debian.org>  Sun, 16 Feb 2025 14:54:48 +0100
