=== debian/control ===
--- 
+++ 
@@ -4,9 +4,11 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+               architecture-is-64-bit,
+               architecture-is-little-endian,
 #               d-shlibs, # Switch to d-shlibs once shared and static lib are built
                cmake,
-               markdown <!nodoc>,
+               discount <!nodoc>,
                libtabixpp-dev,
                libbz2-dev,
                libdisorder-dev,
@@ -15,18 +17,18 @@
                libssw-dev,
                libfastahack-dev,
                libwfa2-dev,
-               pkg-config,
+               pkgconf,
                libgtest-dev <!nocheck>,
                python3-dev,
                python3-pybind11
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/libvcflib
 Vcs-Git: https://salsa.debian.org/med-team/libvcflib.git
 Homepage: https://github.com/vcflib/vcflib
 Rules-Requires-Root: no
 
 Package: libvcflib2
-Architecture: any-amd64 arm64 loong64 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 alpha
+Architecture: any
 Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends},
@@ -47,7 +49,7 @@
     manipulations on VCF files.
 
 Package: libvcflib-dev
-Architecture: any-amd64 arm64 loong64 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 alpha
+Architecture: any
 Multi-Arch: same
 Section: libdevel
 Depends: ${misc:Depends},
@@ -76,7 +78,7 @@
  This package contains the static library and the header files.
 
 Package: libvcflib-tools
-Architecture: any-amd64 arm64 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 alpha
+Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          python3:any,
