=== debian/watch ===
version=4

opts="\
	mode=git, \
	repacksuffix=+dfsg, \
	dversionmangle=auto, \
	uversionmangle=s/-([a-zA-Z]+[\d.]*)/~$1/, \
" \
https://github.com/vcflib/vcflib.git \
refs/tags/v@ANY_VERSION@
